#ifndef DEFAULTINTERFACE_H
#define DEFAULTINTERFACE_H
#include <QObject>
#include <QVariant>
#include <QVector>
#include <KSycoca>
#include <KApplicationTrader>
#include <KSharedConfig>
#include <KConfigGroup>
#include <QDBusArgument>
#include <QDBusMetaType>

struct Service
{
    QString icon;
    QString name;
    QString storageId;
};

const QDBusArgument &operator<<(QDBusArgument &argument, const Service &service);
const QDBusArgument &operator>>(const QDBusArgument &argument, Service &service);
Q_DECLARE_METATYPE(Service)

class DefaultInterface : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.ukui.ukcc.session.Default")
    Q_PROPERTY(QMap <QString , QVariant> sysDefaultList READ getSystemDefaultAppList)
public:
    DefaultInterface();

private:
    QString mLocalMimefile = NULL;
    static QMap <QString , QVariant> mSysDefaultList;
    QStringList mBrowserMimeTypeList;
    QStringList mMailMimeTypeList;
    QStringList mTextMimeTypeList;

protected:
    QMap <QString , QVariant> getSystemDefaultAppList();

public Q_SLOTS:
    QVariantList getDefaultApp(const QString &mimeType);
    QVariantList getAppList(const QString &mimeType);
    void setDefaultApp(const QString &storageId, const QString &mimeType);
    void saveMimeTypeAssociation(const QString &mime, const QString &storageId);

};

#endif // DEFAULTINTERFACE_H
